<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}


//--------------------------------
// Load classes
//--------------------------------
require 'inc/class_thread.php';
require 'inc/class_uploads.php';

//---------------------------------
// Check if i have submit the form
//---------------------------------
$this->classes->lang->load('newthread');

	
if(!isset($_POST['forumid']))
{
	if(!isset($_GET['fid']) || $_GET['fid']=='')
		$this->classes->error->simple_error('no_fid');
	
	$fid=$_GET['fid'];
	
		
	$query = $this->classes->db->execQuery($this->classes->db->sql_build('showforum_nav', array($fid, $this->classes->user->info_user['level'])));
	$nav=$this->classes->db->fetch_array($query);
	
	$nav['type'] = '<a href="#" class="nav">'.$this->classes->lang->lang_all['newthread']['main']['title'].'</a>';
	$nav['forumid'] = $fid;
	$this->classes->skin->assign('nav', $nav);
	
	//can view, can read | can read, can start, can upload
	if(! ($nav['perm'][3] ) )
			$this->classes->error->login_error('no_perm');

	$newpost['type'] = 'newthread';
	$newpost['forumid'] = $fid;
	$newpost['thread_id'] = 0;
	$newpost['formaction'] = 'index.php?act=newthread';
	$newpost['title'] = $this->classes->lang->language['title'];
	$newpost['text'] = 0;
	
	$this->classes->skin->assign('newpost', $newpost);
}
else
{
	if(!strstr($_SERVER['HTTP_REFERER'],$this->classes->_config['board_domain']))
		$this->classes->error->simple_error('no_perm');
		
	$thread=new Thread($this->classes);
	
	$this->classes->var_filtrer->add($_POST);
	$forumid=$this->classes->var_filtrer->Integer('forumid');
	$text=trim($_POST['replybox']);
	$title=trim($this->classes->var_filtrer->String('title', 0));
	$options=$this->classes->var_filtrer->String('options');
	$subscribe=$this->classes->var_filtrer->Integer('subscribe');
	$username = $this->classes->var_filtrer->String('username',0);
	
	if(strlen($title)<3)
		$this->classes->error->simple_error('title_len');
		
	if(strlen($text)<5)
		$this->classes->error->simple_error('text_len');
	
	if($this->classes->user->info_user['level'] < 1)
		if(strlen($username)<2)
			$this->classes->error->simple_error('spec_username');
		else
			$this->classes->user->info_user['user_nick'] = $username;
	//--------------------------------
	// Upload file
	//--------------------------------			
	if(strlen($_FILES['upload']['name'])>5)
	{
		$up = new File_Upload($this->classes);
		$upid = $up->process();
	}
	else
		$upid = 1;
	
	
	$return_thread = $thread->new_thread($title, $text, 0, $forumid, $this->classes->user->info_user, 0, $this->classes->var_filtrer->Integer('bbcodecheck'));
	
	//--------------------------------
	// Insert poll into a thread
	//--------------------------------	
	if(isset($_POST['poll_title']))
	{
		$keys = array_keys($_POST);
					
		$count = count($keys);
		$j=1;
		
		for($i=0; $i<$count;$i++)
		{
			if(strstr($keys[$i], 'poll_') && $keys[$i] != 'poll_title')
			{
				$temp_poll[$j][0] = $_POST[$keys[$i]];
				$temp_poll[$j++][1] = 0;
			}
				
		}
		
		$temp_poll[0][0] = $_POST['poll_title'];
		$temp_poll[0][1] = 0;
		
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('insert_poll_by_tid', array($return_thread['thread_id'], serialize($temp_poll) ) ));
		
		$poll_id = $this->classes->db->insert_id();
		
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('update_pollid_by_tid', array($poll_id, $return_thread['thread_id'] ) ));
	}
	
	
	if( $this->classes->user->info_user['level'] <= 5)
		$options='none';
	
	switch($options)
	{
		case 'pin': $thread->pin_thread($return_thread['thread_id']); break;
		case 'close': $thread->close_thread($return_thread['thread_id']); break;
		case 'closepin': $thread->pin_thread($return_thread['thread_id']); $thread->close_thread($return_thread['thread_id']); break;
	}
	
	if( $subscribe == 1 )
		$thread->thread_subscribe( $topicid );
		
	if($upid != 1)
	{
		$this->classes->db->execQuery($this->classes->db->sql_build('fetch_post_text_pid', array($upid, $return_thread['post_id']) ));
	}
	
	$this->classes->error->complete('index.php?act=showthread&tid='.$return_thread['thread_id'], $this->classes->lang->language['lang_done']);
	
}

?>