<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/

if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

//--------------------------------
// Load classes
//--------------------------------
require 'inc/class_thread.php';

$this->classes->lang->load('showthread');

if(isset($_POST['code']) || isset($_GET['code']))
	{
	
	if(isset($_POST['code']))
		$code=intval($_POST['code']);
	else
		$code=intval($_GET['code']);
		
	$tid=intval($_POST['tid']);
	
	switch($code)
		{
		case '01': { 
					if( !($this->classes->user->info_user['level'] > 4) )
						$this->classes->error->simple_error('no_perm');
					
					$topic=new Thread($this->classes);
					
					$topic->pin_thread($tid); 
					
					$this->classes->error->complete('index.php?act=showthread.php&tid='.$tid, $this->classes->lang->language['pin_done']);
					
					} break;
		case '02': {
					if( !($this->classes->user->info_user['level'] > 4) )
						$this->classes->error->simple_error('no_perm');
					
					$topic=new Thread($this->classes);
					
					$topic->unpin_thread($tid); 
					
					$this->classes->error->complete('index.php?act=showthread.php&tid='.$tid, $this->classes->lang->language['unpin_done']);
					
					} break;
		case '03': { 
					if( !($this->classes->user->info_user['level'] > 4) )
						$this->classes->error->simple_error('no_perm');
					
					$topic=new Thread($this->classes);
					
					$topic->close_thread($tid); 
					
					$this->classes->error->complete('index.php?act=showthread.php&tid='.$tid, $this->classes->lang->language['closed_done']);
					
					} break;
		case '04': {
					
					if( $this->classes->user->info_user['level'] < 1 )
						$this->classes->error->simple_error('no_perm');
					
					$query=$this->classes->db->execQuery($this->classes->db->sql_build('fetch_upload_by_upload_id', $_GET['id']));
					
					$temp=$this->classes->db->fetch_array($query);
					
					if(!$this->classes->user->has_visited($_GET['id'],'upload')) 
						$this->classes->db->execQuery($this->classes->db->sql_build('update_upload_hits', $_GET['id']));
					
					
					header('Content-type: '.$temp['upload_type']);
					header('Content-Disposition: attachment; filename='.$temp['upload_name']);
					header('Content-Description: Download PHP');
					header('Content-Length: '.$temp['upload_size']);
					readfile('uploads/'.$temp['upload_file']);
					exit;
					} break;
		case '05': {	
					if( !($this->classes->user->info_user['level'] > 4) )
						$this->classes->error->simple_error('no_perm');
						
					$tid=intval($_GET['tid']);
						
					if(!isset($_GET['confirm']))
					{
						$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_thread_by_id', $tid ));
						$temp = $this->classes->db->fetch_array($query);
						$this->classes->error->confirm($this->classes->lang->language['delete_confirm'].'<strong>'.$temp['title'].'</strong>?', 'index.php?act=showthread&code=05&tid='.$tid.'&confirm=1');
					}
					
					require 'inc/class_forum.php';
					
					$query=$this->classes->db->execQuery($this->classes->db->sql_build('fetch_fid_by_tid', $tid));
					
					$temp=$this->classes->db->fetch_array($query);
					
					$topic=new Thread($this->classes);
					
					$topic->delete_thread($tid); 
					
					$forum= new Forum($this->classes);
					
					$forum->sync_forum($temp['forumid']);
					
					$this->classes->error->complete('index.php?act=showforum&fid='.$temp['forumid'], $this->classes->lang->language['delete_post_done']);
					} break;
		case '06': {
					if( !($this->classes->user->info_user['level'] > 4) )
						$this->classes->error->simple_error('no_perm');
						
					$tid=intval($_GET['tid']);
						
					if(!isset($_GET['last']))
					{
						$query = $this->classes->db->execQuery($this->classes->db->sql_build('showthread_nav', array($tid, $this->classes->user->info_user['user_group'])));
						$nav=$this->classes->db->fetch_array($query);
		
						//can view, can read | can read, can start, can upload
	
						/*if(! ($nav['perm'][2] ) )
							$this->classes->error->login_error('no_perm'); */
		
						$this->classes->skin->assign('nav', $nav);
						
						$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_forum_list_move', $this->classes->user->info_user['user_id'] ));
						
						while($vett=$this->classes->db->fetch_array($query))
						{
							if( (!$vett['perm'][0]) && $this->classes->user->info_user['admincp']!=1)
								continue;
								
							$menu[$vett['forum_id']] = $vett['title'];
						}
						
						$html = '<tr>
             <td class="board-statistics-bg" style="width:10%;"><div align="center">Forum di destinazione: </div></td>
             <td class="board-statistics-bg" style="width:10%;">'.menu_create('destforum', $menu, 0, 0).'</td>
           	 </tr>';
			 
			 			$formaction = 'index.php?act=showthread&amp;tid='.$tid.'&amp;code=06&amp;last=1';
						
						$this->classes->error->confirm2($html, $formaction);
						
					}
					else
					{
						$destforum=intval($_POST['destforum']);
						
						require 'inc/class_forum.php';
						
						$query=$this->classes->db->execQuery($this->classes->db->sql_build('fetch_fid_by_tid', $tid));
						
						$temp=$this->classes->db->fetch_array($query);
						
						$topic=new Thread($this->classes);
						
						$topic->move_thread($tid, $destforum); 
						
						$forum= new Forum($this->classes);
						
						$forum->sync_forum($temp['forumid']);
						
						$forum->sync_forum($destforum);
						
						$this->classes->error->complete('index.php?act=showforum&fid='.$destforum, $this->classes->lang->language['move_done']);
					}
				}break;
		case '07': { 
					
					$this->classes->var_filtrer->add($_POST);

					$tid = $this->classes->var_filtrer->Integer('tid');
					$voted_choice = $this->classes->var_filtrer->String('poll_vote');
					
					//permission control
					$query = $this->classes->db->execQuery($this->classes->db->sql_build('showthread_nav', array($tid, $this->classes->user->info_user['user_group'])));
					$nav=$this->classes->db->fetch_array($query);
					
					if(! ($nav['perm'][3] ) )
						$this->classes->error->login_error('no_perm');
					
					$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_poll_by_tid', $tid));
					
					if($this->classes->db->num_rows($query) != 1)
						$this->classes->error->simple_error('no_poll');
					else
						$vett = $this->classes->db->fetch_array($query);
						
					$temp = unserialize($vett['questions']);
					
					
					$search = false;
					$count = count($temp);
					
					
					for($i=0; $i<$count; $i++)
					{
						if(@strstr($temp[$i][0], $_POST['poll_vote']))
						{
							$search = $i;
							break;
						}
					}
					//$search = array_search($voted_choice,$temp);
					
					if($search == false)
						$this->classes->error->simple_error('err_poll');
						
					//total posts
					$temp[0][1]++;
					$temp[$i][1]++;
					
					$query = $this->classes->db->execQuery($this->classes->db->sql_build('update_poll_by_tid', array(serialize($temp), $vett['pid']) ));
					
					$query = $this->classes->db->execQuery($this->classes->db->sql_build('insert_voter', array( ip2long($_SERVER['REMOTE_ADDR']), time(), $tid, $this->classes->user->info_user['user_id'] )));
					
					$this->classes->error->complete('index.php?act=showthread&tid='.$tid, $this->classes->lang->language['vote_done']);
					
					} break;
		case '08': {
					if(!$_SESSION['modcp'] )
						$this->classes->error->simple_error('no_perm');
					
					$tid=intval($_GET['tid']);
					$this->classes->var_filtrer->add($_GET);
	
					$tid = $this->classes->var_filtrer->Integer('tid');
					$pid = $this->classes->var_filtrer->Integer('post_id');
					
					$topic = new Thread($this->classes);
					
					$topic->delete_post($tid, $pid);
					
					require 'inc/class_forum.php';
					
					$query=$this->classes->db->execQuery($this->classes->db->sql_build('fetch_fid_by_tid', $tid));
					
					$temp=$this->classes->db->fetch_array($query);
					
					$forum = new Forum($this->classes);
					
					$forum->sync_forum($temp['forumid']);
					
					$this->classes->error->complete('index.php?act=showthread&tid='.$tid, $this->classes->lang->language['delete_post_done']);
					} break;
		}
	exit;
	}
else
	{

	if(!isset($_GET['tid']))
		$this->classes->error->simple_error('no_tid');
	
	$tid=intval($_GET['tid']);
	$options=addslashes($_POST['options']);
	
	if(!isset($_GET['start']))
		$start=0;
	else
		$start = abs(intval($_GET['start']));
		
	$this->classes->skin->cache = true;	
	
	if(!$this->classes->skin->is_cached('main.tpl', $act.$tid.$start.$this->classes->user->info_user['level'])) {
	//--------------------------------
	// Navigation
	//--------------------------------
	$query = $this->classes->db->execQuery($this->classes->db->sql_build('showthread_nav', array($tid, $this->classes->user->info_user['user_group'])));
	$nav=$this->classes->db->fetch_array($query);
	
	//can view, can read | can read, can start, can upload

	if(! ($nav['perm'][2] ) )
			$this->classes->error->login_error('no_perm'); 
	
	$this->classes->skin->assign('nav', $nav);
	
	
	//--------------------------------
	// Initial thread informations
	//--------------------------------
	$thread=new Thread($this->classes, $tid);
	
	if(!$this->classes->user->has_visited($tid,'')) 
		$thread->update_views($tid);
	
		
	$thread->thread['dateline'] = date("d/m/Y h:i:s",$thread->thread['dateline']);
	
	$this->classes->skin->assign('threadinfos', $thread->thread);

	//--------------------------------
	// Poll informations
	//--------------------------------	
	if($thread->thread['pollid']!=0)
	{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_poll_and_voters_by_tid', $tid ));
		$vett = $this->classes->db->fetch_array($query);
		
		$query2 = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_voter_by_id', array($this->classes->user->info_user['user_id'], $tid) ));
		$voted = $this->classes->db->num_rows($query2);
		
		
		$temp_exp = unserialize($vett['questions']);
		
		$tot = count($temp_exp);
		
		$poll_info['title'] = $temp_exp[0][0];
		$poll_info['tid'] = $tid;
		$poll_info['voted'] = $voted;
		
		for($i=1;$i<$tot;$i++)
		{
			
			$opt[$i-1]['title'] = $temp_exp[$i][0];
			$opt[$i-1]['votes'] = $temp_exp[$i][1];
			$score = ($temp_exp[0][1] == 0) ? 0 : intval((100*$temp_exp[$i][1])/$temp_exp[0][1]);
			$opt[$i-1]['score'] =  $score*2;
			$opt[$i-1]['perc'] = $score;
		
		}
		
		$this->classes->skin->assign('poll_info', $poll_info);
		$this->classes->skin->assign('poll_opt', $opt);
		
	}
	
	
	$query=$this->classes->db->execQuery($this->classes->db->sql_build('update_thread_subscribe_sent', array($tid, $this->classes->user->info_user['user_id']) ));
	$query=$this->classes->db->execQuery($this->classes->db->sql_build('count_posts_by_tid', $tid));
	$num=$this->classes->db->fetch_array($query);
	
	if(isset($_GET['view']))
	{
		$start = intval(($num['tot']-1)/10)*10;
	}
	
   	$thread->fetch_posts_by_tid($tid, $start);

	
	
	
	
	$this->classes->skin->assign('pages', generate_pagination($this->classes->_config['board_domain'].$this->classes->_config['board_url'].'index.php?act=showthread&tid='.$tid.'&start=', $num['tot'], 10, $start));
	}
	}

$add = $tid.$start;
?>