<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
	
class database
	{
	/**
    * database connection
    * @access Private
    * @var ?
    */
	var $db;
	
	/**
    * Connection configs
    * @access Private
    * @var array->string
    */
	var $config;
	
	/**
    * Working uery
    * @access Private
    * @var ?
    */
	var $now_query;
	
	/**
    * number of executed queries
    * @access Public
    * @var int
    */
	var $num_query;
	
	/**
    * Database Constructor
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function database($CONFIG)
		{
		$this->db=0;
		$this->now_query=0;
		$this->num_query=0;
		
		$this->config=$CONFIG;
		}
	
	/**
    * Connect to database
    *
    * @param string $database
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function connect()
		{
		if(!$this->db=sqlite_open($this->config['dbname'], 0666, $error))
			{
			echo 'Errore connessione database';
			exit;
			}
		
		}

	/**
    * close the database connection
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */		
	function disconnect(){
		mysql_close($this->db);
	}
	
	/**
    * Switch database
    *
    * @param string $database
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */	
	function switch_db($database)
		{
		if(!mysql_select_db($database,$this->db))
			{
			echo 'Selezione database fallita';
			exit;
			}
		}
	
	
	/**
    * Execute a query
    *
    * @param ? $query
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function execQuery($query)
		{
		$this->num_query=$this->num_query+1;
		$query2=mysql_query($query,$this->db);
		if(!$query2)
			{
			echo 'Unable to Perform the query: '.$query.'<br>'.mysql_error();
			exit;
			}
		else
		return $query2;
		}
		
	/**
    * Put the results in an array
    *
    * @param ? $query
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return array()
    */
	function fetch_array($query)
		{
		return mysql_fetch_array($query, MYSQL_ASSOC);
		}

	/**
    * Return the num of the rows selected
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return integer
    */
	function num_rows($query)
	{
		return mysql_num_rows($query);
	}
		
	function insert_id()
	{
		return mysql_insert_id();
	}


	/**
    * This function runs the template through sprintf and passes any given parameters.
    *
    * @param string $template, array $params
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return ?query
    */		
	function sql_build($template, $params=array()) 
		{
	  	require 'mysql_queries.php';
	  	if (isset($sql_templates[$template])) 
			{
			// TODO: verify given parameter count matches params for template.
			if (is_array($params)) 
				{
		  		$sql = vsprintf($sql_templates[$template], $params);
				} 
			else 
				{
		  		$sql = sprintf($sql_templates[$template], $params);
				}
			return str_replace('revokebb_', $this->config['prefix'], $sql);
	  		}
	  	return false;
		}
	}



 
?>